﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Core.Layers;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Primitives;
using System.Diagnostics;
using System.Threading;

namespace WindowsFormsApplication5
{
    public partial class Form1 : Form
    {
        private Thread SecondThread = null;
        delegate void AddPoints(XYDataPoint point);
        private XYDataPoint Point;
        private static double dcXvalue;
        private XYSeries BPLseries;

        public Form1()
        {
            InitializeComponent();

            this.ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.Composite;

            ChartArea myChartArea = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(myChartArea);

            // Defines axes
            AxisItem axisX = new AxisItem();
            axisX.DataType = Infragistics.UltraChart.Shared.Styles.AxisDataType.Numeric;
            axisX.Labels.ItemFormatString = "<DATA_VALUE:0.00>";
            axisX.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            axisX.OrientationType = Infragistics.UltraChart.Shared.Styles.AxisNumber.X_Axis;
           // axisX.RangeType = AxisRangeType.Custom;
           // axisX.RangeMin = -1;
           // axisX.RangeMax = 5;
            myChartArea.Axes.Add(axisX);


            AxisItem axisY = new AxisItem();
            axisY.DataType = Infragistics.UltraChart.Shared.Styles.AxisDataType.Numeric;
            axisY.Labels.ItemFormatString = "<DATA_VALUE:0.00>";
            axisY.Labels.HorizontalAlign = StringAlignment.Far;
            axisY.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            axisY.OrientationType = Infragistics.UltraChart.Shared.Styles.AxisNumber.Y_Axis;
            axisY.RangeType = AxisRangeType.Custom;
            axisY.RangeMin = 0;
            axisY.RangeMax = 220;

            myChartArea.Axes.Add(axisY);

            // Create and add series
            BPLseries = new XYSeries();
            BPLseries.Label = "Blood L";
            XYSeries BPHseries = new XYSeries();
            BPHseries.Label = "Blood H";
            XYSeries Pulseseries = new XYSeries();
            Pulseseries.Label = "Pulse";
            //DataTable table = createData();

            //for (int i = 0; i < table.Rows.Count; i++)
            //{
            //    BPLseries.Points.Add(new XYDataPoint((double)(table.Rows[i][0]), (double)table.Rows[i][1], "", false));
            //    BPHseries.Points.Add(new XYDataPoint((double)(table.Rows[i][0]), (double)table.Rows[i][2], "", false));
            //    Pulseseries.Points.Add(new XYDataPoint((double)(table.Rows[i][0]), (double)table.Rows[i][3], "", false));
            //}

            // Add a chartLayerAppearance
            ChartLayerAppearance myScatterLayer = new ChartLayerAppearance();
            myScatterLayer.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.ScatterChart;
            myScatterLayer.ChartArea = myChartArea;
            myScatterLayer.AxisX = axisX;
            myScatterLayer.AxisY = axisY;
            myScatterLayer.Series.Add(BPLseries);
            myScatterLayer.Series.Add(BPHseries);
            myScatterLayer.Series.Add(Pulseseries);

            ScatterChartAppearance sca1 = new ScatterChartAppearance();
            sca1.ConnectWithLines = true;
            sca1.Icon = SymbolIcon.None;
            sca1.LineAppearance.DrawStyle = LineDrawStyle.Dash;
            myScatterLayer.ChartTypeAppearance = sca1;

            this.ultraChart1.Series.Add(BPLseries);
            this.ultraChart1.Series.Add(BPHseries);
            this.ultraChart1.Series.Add(Pulseseries);
            this.ultraChart1.CompositeChart.ChartLayers.Add(myScatterLayer);

            CompositeLegend myLegend = new CompositeLegend();
            myLegend.ChartLayers.Add(myScatterLayer);
            myLegend.Bounds = new Rectangle(88, 2, 11, 15);
            myLegend.BoundsMeasureType = MeasureType.Percentage;
            myLegend.PE.ElementType = PaintElementType.Gradient;
            myLegend.PE.FillGradientStyle = GradientStyle.ForwardDiagonal;
            myLegend.PE.Fill = Color.CornflowerBlue;
            myLegend.PE.FillStopColor = Color.Transparent;
            myLegend.Border.CornerRadius = 10;
            myLegend.Border.Thickness = 1;

            this.ultraChart1.CompositeChart.Legends.Add(myLegend);

            this.SecondThread = new Thread(new ThreadStart(InitPoint));
            this.SecondThread.Start();
        }

        public void InitPoint()
        {
            InitPoint(Point);
        }

        public void InitPoint(XYDataPoint point)
        {
            if (ultraChart1.InvokeRequired)
            {
                for (int i = 0; i < 1000; i++)
                {
                    Thread.Sleep(500);
                    Random rnd = new Random();
                    Point = new XYDataPoint(dcXvalue, rnd.Next(0, 200), "aa", false);
                    AddPoints del = new AddPoints(InitPoint);
                    this.Invoke(del, new XYDataPoint[] { Point });
                    dcXvalue = dcXvalue + 0.1;
                }
            }
            else
            {
                if (BPLseries.Points.Count > 20) BPLseries.Points.RemoveAt(0);
                BPLseries.Points.Add(Point);

            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (SecondThread.IsAlive) SecondThread.Abort();
        }

        private void ultraChart1_MouseDown(object sender, MouseEventArgs e)
        {
            ultraChart1.Cursor = Cursors.Hand;
        }

        private void ultraChart1_MouseUp(object sender, MouseEventArgs e)
        {
            ultraChart1.Cursor = Cursors.Default;
        }
    }
}
